using System;
using System.Drawing;
using System.Windows.Forms;

class DiningRoom : Panel
{
    private Table t;
    Philosopher[] p;
    
    public DiningRoom()
    {
        // table
        this.t = new Table();
        t.BackColor = Color.Beige;
        this.Controls.Add(t);

        // philosophers
        this.p = new Philosopher[5];
        for (int i = 0; i < 5; i++)
        {
            this.p[i] = new Philosopher(this.t, i);
            this.Controls.Add(this.p[i]);
        }
    }
    
    public void StartSupper()
    {
        for (int i = 0; i < 5; i++)
            this.p[i].Start();
    }

    public void StopSupper()
    {
        for (int i = 0; i < 5; i++)
            this.p[i].Stop();
    }
    
    protected override void OnPaint(PaintEventArgs e)
    {
        base.OnPaint(e);

        // modify location of table
        int x = this.Width / 2 - t.Width / 2;
        int y = this.Height / 2 - t.Height / 2;
        t.Location = new Point(x, y);

        // modify location of philosophers
        //this.p[0].BackColor = Color.Red;        // test: where's the 1st?

        this.p[0].Location = new Point(this.t.Left + this.t.Width / 5 * 1, this.t.Top - 40);
        this.p[1].Location = new Point(this.t.Left + this.t.Width / 5 * 4, this.t.Top - 40);
        this.p[2].Location = new Point(this.t.Left + this.t.Width + 40, this.t.Top + this.t.Height / 5 * 3);
        this.p[3].Location = new Point(this.t.Left + this.t.Width / 2, this.t.Top + this.t.Height + 40);
        this.p[4].Location = new Point(this.t.Left - 40, this.t.Top + this.t.Height / 5 * 3);
    }
}
