using System;
using System.Drawing;
using System.Windows.Forms;

public enum Directions{Up, UpRight, Right, BottomRight, Bottom, BottomLeft, Left, UpLeft};

class Fork : Control
{
    public bool isAvailable;
    public Directions direction;
    
    public Fork()
    {
        this.isAvailable = true;
        this.Size = new Size(20, 30);
    }

    protected override void OnPaint(PaintEventArgs e)
    {
        base.OnPaint(e);
        
        Pen pAvailable = new Pen(Brushes.Green, 1.0f);
        Pen pOccupied = new Pen(Brushes.Red, 1.0f);
        Point p1;
        Point p2;
        int x1, x2, y1, y2, startDegree;        
        
        // later, you could implement several directions here
        
        //switch (this.direction)
        //{
        //    case Directions.BottomLeft:
        //        break;
        //    case Directions.UpLeft:
        //        break;
        //    case Directions.Up:
        //        break;
        //    case Directions.UpRight:
        //        break;
        //    case Directions.BottomRight:
        //        break;            
        //    case Directions.Bottom:
        //    default:
                p1 = new Point(6, 1);
                p2 = new Point(6, 20);
                x1 = 1;
                y1 = 15;
                x2 = 10;
                y2 = 20;
                startDegree = 0;
        //        break;
        //}
        
        if(this.isAvailable)
        {
            e.Graphics.DrawLine(pAvailable, p1, p2);
            e.Graphics.DrawArc(pAvailable, x1, y1, x2, y2, startDegree, -180);
        }
        else
        {
            e.Graphics.DrawLine(pOccupied, p1, p2);
            e.Graphics.DrawArc(pOccupied, x1, y1, x2, y2, startDegree, -180);
        }
        
        pAvailable.Dispose();
        pOccupied.Dispose();
    }
}